<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'Tree',
  props: {
    text: {
      type: String,
      required: false,
      default: '',
    },
    dataGaName: {
      type: String,
      required: false,
      default: '',
    },
    dataGaLocation: {
      type: String,
      required: false,
      default: '',
    },
    nodes: {
      type: Array,
      required: false,
      default: () => {
        // eslint-disable-next-line no-unused-expressions
        [];
      },
    },
    depth: {
      type: Number,
      required: false,
      default: 0,
    },
    href: {
      type: String,
      required: false,
      default: '',
    },
    isSelected: {
      type: Boolean,
      required: false,
      default: false,
    },
    mobile: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
});
</script>

<template>
  <div :class="[`depth-${depth}`, { mobile: mobile }]">
    <a
      v-if="text"
      class="anchor"
      :class="{ selected: isSelected }"
      :href="href"
      :data-ga-name="dataGaName"
      :data-ga-location="dataGaLocation"
      >{{ text }}</a
    >
    <Tree
      v-for="node in nodes"
      :key="node.title"
      :nodes="node.nodes"
      :text="node.title"
      :data_ga_name="node.data_ga_name || node.title"
      :data_ga_location="node.data_ga_location || 'side navigation'"
      :href="node.href"
      :depth="depth + 1"
      :is-selected="node.isSelected"
      :mobile="mobile"
    />
  </div>
</template>

<style lang="scss" scoped>
// I arbitrarily picked 5, there's no reason this can't be infinite.
@for $i from 2 through 5 {
  .depth-#{$i} {
    margin-left: $spacing-16 * $i;

    &.mobile {
      margin-left: $spacing-8 * $i;
    }
  }
}

.anchor {
  display: block;
  padding: $spacing-8 $spacing-16;
  color: $color-text-300;
  border-radius: $border-radius-4;
  margin-bottom: $spacing-4;

  &.selected {
    background-color: $color-surface-800;
  }

  &:hover {
    background-color: $color-surface-950;
    color: $color-text-300;
  }
}

.mobile {
  .anchor {
    margin-bottom: 0px;

    &.selected {
      background-color: $color-surface-50;
    }

    &:hover {
      background-color: $color-surface-50;
      color: $color-text-300;
    }
  }
}
</style>
